use sdl2::gfx::primitives::DrawRenderer;
use sdl2::pixels::Color;

use crate::DrawContext;
use crate::Drawable;
use crate::SpriteAtlas;
use crate::WorldPosition;

pub struct Doodad {
	pub sprite: String,
	pub pos: WorldPosition,
	pub scale: u32,
	pub angle: f64,
}

impl Drawable for Doodad {
	fn draw(&self, dc: &mut DrawContext, sa: &SpriteAtlas) -> Result<(), String> {
		let pos = self.pos.screen_position(dc);
		let sprite = sa.get(&self.sprite);
		sprite.draw(dc.canvas, pos, self.angle, 1.0)?;

		let p = self.pos.screen_position_real(dc);
		dc.canvas
			.aa_circle(p.x as i16, p.y as i16, 5, Color::RGB(255, 0, 0))?;
		dc.canvas.set_draw_color(Color::RGB(0, 0, 0));

		return Ok(());
	}
}
